<%#-- copyright
OpenProject is an open source project management software.
Copyright (C) the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<%=
  render(
    FormControl.new(
      input: @input,
      classes: "pattern-input",
      "data-controller": "pattern-input",
      "data-pattern-input-pattern-initial-value": @value,
      "data-pattern-input-insert-as-text-template-value": I18n.t("types.edit.subject_configuration.pattern.insert_as_text"),
      "data-pattern-input-suggestions-initial-value": suggestions_for_stimulus
    )
  ) do
%>
  <%= content_tag(:div, **@field_wrap_arguments) do %>
    <%= @input.builder.hidden_field(name, value: @value, data: { "pattern-input-target": "formInput" }) %>

    <template data-pattern-input-target="tokenTemplate">
      <%= render(Primer::Beta::Label.new(tag: :span, scheme: :accent, "data-role": :token)) %>
    </template>

    <template data-pattern-input-target="suggestionsHeadingTemplate">
      <%= render(Primer::Alpha::ActionList::Heading.new(title: "__placeholder__", heading_level: 2)) %>
    </template>

    <template data-pattern-input-target="suggestionsDividerTemplate">
      <%= render(Primer::Alpha::ActionList::Divider.new) %>
    </template>

    <template data-pattern-input-target="suggestionsItemTemplate">
      <%=
        render(
          Primer::Alpha::ActionList::Item.new(
            list: suggestions_list_component,
            label: "__placeholder__",
            role: "menuitem",
            data: {
              prop: "__placeholder__",
              action: "click->pattern-input#suggestions_select"
            }
          )
        )
      %>
    </template>

    <template data-pattern-input-target="insertAsTextTemplate">
      <%=
        render(
          Primer::Alpha::ActionList::Item.new(
            list: suggestions_list_component,
            label: "__placeholder__",
            role: "menuitem",
            label_classes: "fgColor-muted text-italic",
            data: {
              action: "click->pattern-input#close_suggestions"
            }
          )
        )
      %>
    </template>

    <%=
      render(
        Primer::BaseComponent.new(
          tag: :div,
          contenteditable: true,
          border: true, border_radius: 2, p: 1, classes: :input,
          "data-pattern-input-target": "content",
          data: {
            action: "keydown->pattern-input#input_keydown
                   input->pattern-input#input_change
                   mouseup->pattern-input#input_mouseup
                   focus->pattern-input#input_focus
                   blur->pattern-input#input_blur"
          }
        )
      )
    %>
    <%= render(Primer::BaseComponent.new(tag: :div, box_shadow: :medium, border_radius: 2)) do %>
      <focus-group direction="vertical">
        <%= render(suggestions_list_component) %>
      </focus-group>
    <% end %>
  <% end %>
<% end %>
